# spacetower_orbital_state_management
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Generator version: 7.6.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import spacetower_orbital_state_management
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import spacetower_orbital_state_management
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import spacetower_orbital_state_management
from spacetower_orbital_state_management.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.exoops.exotrail.space/orbital-state-management/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = spacetower_orbital_state_management.Configuration(
    host = "https://api.exoops.exotrail.space/orbital-state-management/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure HTTP basic authorization: basicAuth
configuration = spacetower_orbital_state_management.Configuration(
    username = os.environ["USERNAME"],
    password = os.environ["PASSWORD"]
)


# Enter a context with an instance of the API client
with spacetower_orbital_state_management.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = spacetower_orbital_state_management.DefaultApi(api_client)
    id = 'id_example' # str | The unique identifier of the orbital state

    try:
        # Delete the orbital state with the given id
        api_instance.delete_orbital_state(id)
    except ApiException as e:
        print("Exception when calling DefaultApi->delete_orbital_state: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.exoops.exotrail.space/orbital-state-management/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**delete_orbital_state**](docs/DefaultApi.md#delete_orbital_state) | **DELETE** /orbital-states/{id} | Delete the orbital state with the given id
*DefaultApi* | [**delete_orbital_states**](docs/DefaultApi.md#delete_orbital_states) | **DELETE** /orbital-states | Delete all orbital states of the given object
*DefaultApi* | [**get_orbital_state**](docs/DefaultApi.md#get_orbital_state) | **GET** /orbital-states/{id} | Retrieve the orbital state with the given id
*DefaultApi* | [**get_orbital_states**](docs/DefaultApi.md#get_orbital_states) | **GET** /orbital-states | Retrieve orbital states of the given object
*DefaultApi* | [**save_orbital_state**](docs/DefaultApi.md#save_orbital_state) | **POST** /orbital-states | Save a new reference orbital state


## Documentation For Models

 - [AnomalyType](docs/AnomalyType.md)
 - [AtmosphereModel](docs/AtmosphereModel.md)
 - [AtmosphereType](docs/AtmosphereType.md)
 - [AtmosphericDragPerturbation](docs/AtmosphericDragPerturbation.md)
 - [AttitudeLaw](docs/AttitudeLaw.md)
 - [AttitudeLawType](docs/AttitudeLawType.md)
 - [BatteryModel](docs/BatteryModel.md)
 - [BoxObject](docs/BoxObject.md)
 - [CartesianCovarianceFrameId](docs/CartesianCovarianceFrameId.md)
 - [CartesianCovarianceMatrix](docs/CartesianCovarianceMatrix.md)
 - [CartesianOrbit](docs/CartesianOrbit.md)
 - [CelestialBodyName](docs/CelestialBodyName.md)
 - [CircularOrbit](docs/CircularOrbit.md)
 - [CovarianceOrbitType](docs/CovarianceOrbitType.md)
 - [EarthCenteredFrameId](docs/EarthCenteredFrameId.md)
 - [EarthOrientedManeuverAttitudeLaw](docs/EarthOrientedManeuverAttitudeLaw.md)
 - [EarthPotentialPerturbation](docs/EarthPotentialPerturbation.md)
 - [EquinoctialOrbit](docs/EquinoctialOrbit.md)
 - [FixedStepIntegratorConfiguration](docs/FixedStepIntegratorConfiguration.md)
 - [FixedStepIntegratorType](docs/FixedStepIntegratorType.md)
 - [HarrisPriesterAtmosphere](docs/HarrisPriesterAtmosphere.md)
 - [InertialFrameId](docs/InertialFrameId.md)
 - [IntegratorConfiguration](docs/IntegratorConfiguration.md)
 - [IntegratorType](docs/IntegratorType.md)
 - [IsotropicObject](docs/IsotropicObject.md)
 - [KeplerianOrbit](docs/KeplerianOrbit.md)
 - [LocalFrameAttitudeLaw](docs/LocalFrameAttitudeLaw.md)
 - [ManeuverDirectionType](docs/ManeuverDirectionType.md)
 - [MeanOsculatingOrbitType](docs/MeanOsculatingOrbitType.md)
 - [MetaData](docs/MetaData.md)
 - [NadirPointingLaw](docs/NadirPointingLaw.md)
 - [NrlMsise00Atmosphere](docs/NrlMsise00Atmosphere.md)
 - [Orbit](docs/Orbit.md)
 - [OrbitType](docs/OrbitType.md)
 - [OrbitalCovarianceMatrix](docs/OrbitalCovarianceMatrix.md)
 - [OrbitalElementsCovarianceMatrix](docs/OrbitalElementsCovarianceMatrix.md)
 - [OrbitalState](docs/OrbitalState.md)
 - [OrbitalStateContext](docs/OrbitalStateContext.md)
 - [OrbitalStateOrbitData](docs/OrbitalStateOrbitData.md)
 - [Perturbation](docs/Perturbation.md)
 - [PerturbationType](docs/PerturbationType.md)
 - [PowerSystem](docs/PowerSystem.md)
 - [ProblemDetail](docs/ProblemDetail.md)
 - [PropulsionPowerModel](docs/PropulsionPowerModel.md)
 - [RadiationCoefficients](docs/RadiationCoefficients.md)
 - [RadiationCoefficientsType](docs/RadiationCoefficientsType.md)
 - [ReflectionAbsorptionCoefficients](docs/ReflectionAbsorptionCoefficients.md)
 - [RotatingLocalFrameId](docs/RotatingLocalFrameId.md)
 - [RotationOrder](docs/RotationOrder.md)
 - [SavedOrbitalState](docs/SavedOrbitalState.md)
 - [SimulationConfiguration](docs/SimulationConfiguration.md)
 - [SingleRadiationCoefficient](docs/SingleRadiationCoefficient.md)
 - [SolarArrayGeometry](docs/SolarArrayGeometry.md)
 - [SolarRadiationPressurePerturbation](docs/SolarRadiationPressurePerturbation.md)
 - [SolidTidesPerturbation](docs/SolidTidesPerturbation.md)
 - [SpaceObject](docs/SpaceObject.md)
 - [SpaceObjectType](docs/SpaceObjectType.md)
 - [Status](docs/Status.md)
 - [SunEnhancedManeuverAttitudeLaw](docs/SunEnhancedManeuverAttitudeLaw.md)
 - [SunPointingLaw](docs/SunPointingLaw.md)
 - [TLE](docs/TLE.md)
 - [ThirdBodiesGravityPerturbation](docs/ThirdBodiesGravityPerturbation.md)
 - [Thruster](docs/Thruster.md)
 - [TwoLineElementOrbit](docs/TwoLineElementOrbit.md)
 - [VariableStepIntegratorConfiguration](docs/VariableStepIntegratorConfiguration.md)
 - [VariableStepIntegratorType](docs/VariableStepIntegratorType.md)
 - [Vector3D](docs/Vector3D.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="basicAuth"></a>
### basicAuth

- **Type**: HTTP basic authentication


## Author




