# coding: utf-8

"""
    Orbital State Management API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from spacetower_orbital_state_management.models.orbit import Orbit
from spacetower_orbital_state_management.models.orbital_covariance_matrix import OrbitalCovarianceMatrix
from typing import Optional, Set
from typing_extensions import Self

class OrbitalStateOrbitData(BaseModel):
    """
    The orbit data contains the orbital characteristics at a given date, expressed in orbital elements or position and velocity coordinates (Cartesian parameters), and an optional 6*6 covariance matrix
    """ # noqa: E501
    orbit: Orbit
    covariance_matrix: Optional[OrbitalCovarianceMatrix] = Field(default=None, alias="covarianceMatrix")
    __properties: ClassVar[List[str]] = ["orbit", "covarianceMatrix"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrbitalStateOrbitData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of orbit
        if self.orbit:
            _dict['orbit'] = self.orbit.to_dict()
        # override the default output from pydantic by calling `to_dict()` of covariance_matrix
        if self.covariance_matrix:
            _dict['covarianceMatrix'] = self.covariance_matrix.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrbitalStateOrbitData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "orbit": Orbit.from_dict(obj["orbit"]) if obj.get("orbit") is not None else None,
            "covarianceMatrix": OrbitalCovarianceMatrix.from_dict(obj["covarianceMatrix"]) if obj.get("covarianceMatrix") is not None else None
        })
        return _obj


