# coding: utf-8

"""
    Orbital State Management API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Union
from typing_extensions import Annotated
from spacetower_orbital_state_management.models.radiation_coefficients import RadiationCoefficients
from spacetower_orbital_state_management.models.radiation_coefficients_type import RadiationCoefficientsType
from typing import Optional, Set
from typing_extensions import Self

class ReflectionAbsorptionCoefficients(RadiationCoefficients):
    """
    Radiation properties described by specular reflection and absorption coefficients. The sum of the <br> coefficients must be less or equal to 1. 
    """ # noqa: E501
    specular_reflection_coefficient: Union[Annotated[float, Field(le=1, strict=True, ge=0)], Annotated[int, Field(le=1, strict=True, ge=0)]] = Field(description="Dimensionless specular reflection coefficient. It must be in the range [0, 1]. Units [-].", alias="specularReflectionCoefficient")
    absorption_coefficient: Union[Annotated[float, Field(le=1, strict=True, ge=0)], Annotated[int, Field(le=1, strict=True, ge=0)]] = Field(description="Dimensionless absorption coefficient. It must be in the range [0, 1]. Units [-].", alias="absorptionCoefficient")
    __properties: ClassVar[List[str]] = ["radiationCoefficientsType", "specularReflectionCoefficient", "absorptionCoefficient"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReflectionAbsorptionCoefficients from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReflectionAbsorptionCoefficients from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "radiationCoefficientsType": obj.get("radiationCoefficientsType"),
            "specularReflectionCoefficient": obj.get("specularReflectionCoefficient"),
            "absorptionCoefficient": obj.get("absorptionCoefficient")
        })
        return _obj


